/***********************************************************
* Project:	CS298                                          *
* File:		Segment1.hpp                                   *
* Purpose:	This file contains member functions that are   *
*			used in the painter's algorithm.               *
************************************************************/

#include "types.h"
#include "polyhedron4.hpp"

class Segment
{
private:
	Poly3 **_polygonlist;//An array of pointers to Poly3s
	int _maxcount;
	int _freeindex;
public:
	Segment(int maxcount);
	~Segment();
	void Empty();
	void Post(const Poly3 &p);
	void Post(const Polyhedron3 &p);
	void RoomPost(const Polyhedron3 &p);
	void Sort();
	void Draw(GDIToolbox &gdibox);
};

